package com.oreilly.jent.jndi;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

/**
 * listen: Command to listen for events in a JNDI context.
 */

import java.util.Vector;

import javax.naming.Context;
import javax.naming.NamingException;
import javax.naming.event.EventContext;
import javax.naming.event.EventDirContext;
import javax.naming.event.NamingListener;

class listen implements Command {
  public void execute(Context c, Vector v) throws CommandException {
        
    if (NamingShell.getCurrentContext() == null)
      throw new CommandException(new Exception(), "No current context");
    else if (v.isEmpty())
      throw new CommandException(new Exception(), "No target specified");
    String name = (String)v.firstElement();
    String filter = null;
    if (v.size() > 1) {
      filter = (String)v.elementAt(1);
    }
    
    try {
      // Cast context to an event context
      EventContext evCtx = (EventContext)c;
      // Create our listener
      NamingListener listener = new AnyChangeLogger();
      // If no filter specified, just register a listener using EventContext
      if (filter == null) {
        evCtx.addNamingListener(name, EventContext.OBJECT_SCOPE, listener);
      }
      // If we have a filter, use the EventDirContext to specify the target
      else {
        EventDirContext evDirCtx = (EventDirContext)c;
        evDirCtx.addNamingListener(name, filter, null, listener);
      }
      System.out.println("Registered listener for " + name +
                         (filter != null ? (" and filter " + filter) : ""));
    }
    catch (ClassCastException cce) {
      cce.printStackTrace();
      throw new CommandException(cce,
                  "The current context does not support event notification.");
    }
    catch (NamingException e) {
      throw new CommandException(e, "The search for " + filter + " failed");
    }
  }

  public void help() { System.out.println("Usage: listen name [filter]"); }
}
